import java.util.Objects;

public class NonEmptyListNode implements AbstrListNode {
    private String value;
    private AbstrListNode next;

    public NonEmptyListNode(String value, AbstrListNode next) {
        this.value = value;
        this.next = next;
    }

    @Override
    public String value() {
        return value;
    }

    @Override
    public AbstrListNode next() {
        return next;
    }

    @Override
    public AbstrListNode addLast(String value) {
        next = next.addLast(value);
        return this;
    }

    @Override
    public AbstrListNode peekLast() {
        return next.ifEmpty(this, next.peekLast());
    }

    @Override
    public AbstrListNode removeLast() {
        AbstrListNode result = next.ifEmpty(next, this);
        next = next.removeLast();
        return result;
    }

    @Override
    public boolean isEmpty() {
        return false;
    }

    @Override
    public AbstrListNode ifEmpty(AbstrListNode whenEmpty, AbstrListNode whenNotEmpty) {
        return whenNotEmpty;
    }

    @Override
    public String toString() {
        return "\"" + value + "\"." + next;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        NonEmptyListNode that = (NonEmptyListNode) o;
        return this.value.equals(that.value) &&
                this.next.equals(that.next);
    }

    @Override
    public int hashCode() {
        return value.hashCode() + next.hashCode();
    }

}
