public class HashTabData implements AssocData {
    private Data[] ks = new Data[65];
    private String[] vs = new String[65];
    private int count = 0;

    private int find(Data k) {
        if (k == null) {
            return ks.length - 1;
        }
        int i = k.hashCode() & (ks.length - 2);
        while (ks[i] != null && !ks[i].equals(k)) {
            i = (i + 1) & (ks.length - 2);
        }
        return i;
    }

    public String put(Data k, String v) {
        if (k == null) {
            return null;
        }
        int i = find(k);
        String old = vs[i];
        vs[i] = v;
        if (ks[i] == null) {
            ks[i] = k;
            if (++count >= ks.length * 3 / 4) {
                Data[] oks = ks;
                String[] ovs = vs;
                ks = new Data[(oks.length << 1) - 1];
                vs = new String[(oks.length << 1) - 1];
                for (int j = 0; j < oks.length; j++) {
                    if (oks[j] != null) {
                        ks[i = find(oks[j])] = oks[j];
                        vs[i] = ovs[j];
                    }
                }
            }
        }
        return old;
    }

    public String get(Data k) {
        return vs[find(k)];
    }

    public boolean containsKey(Data k) {
        return ks[find(k)] != null;
    }

    public String toString() {
        String s = "";
        for (int i = 0; i < ks.length - 1; i++) {
            if (ks[i] != null) {
                s += (s.isEmpty() ? "(" : ", (") + ks[i] + ", " + vs[i] + ")";
            }
        }
        return "{" + s + "}";
    }

}
