public class TestAssocData {
    private static final int NUM = 1000;

    public static void main(String[] args) {
        testAll();
    }

    private static void testAll() {
        HashTabData h = new HashTabData();
        TreeAssocData t = new TreeAssocData();

        testAssoc(h);
        testAssoc(t);
    }

    private static void testAssoc(AssocData assoc) {
        final String name = assoc.getClass().getName();
        long cnt = 0;
        System.out.println("Einfügen in " + name + ":");
        for (int i = 1; i <= NUM; i += 2) {
            if (assoc.put(new Data(i, "Key" + i), "Value" + i) != null) {
                cnt++;
            }
        }
        System.out.println(cnt + " Einträge waren schon vorhanden.");
        cnt = 0;
        System.out.println("Auslesen aus " + name + " mit containsKey:");
        for (int i = 1; i <= NUM; i += 3) {
            if (assoc.containsKey(new Data(i, "Key" + i))) {
                cnt++;
            }
        }
        System.out.println(cnt + " Einträge wurden gefunden.");
        cnt = 0;
        System.out.println("Auslesen aus " + name + " mit get:");
        for (int i = 1; i <= NUM; i += 3) {
            if (assoc.get(new Data(i, "Key" + i)) != null) {
                cnt ++;
            }
        }
        System.out.println(cnt + " Einträge wurden gefunden.");
        System.out.println("Ausgeben der Inhalte:");
        System.out.println(assoc);
        System.out.println(name + " fertig getestet");
    }




    private static final int RANGE = 100000000;
    private static int rand() {
        return (int)(Math.random() * RANGE);
    }
}
