public class OTNode {
    private String elem;
    private OTNode left, right;

    public OTNode(String e) {
        elem = e;
    }

    private int compare(String e) {
        if (e == null) {
            return elem == e ? 0 : -1;
        }
        return elem == null ? 1 : e.compareTo(elem);
    }

    public void add(String e) {
        int cmp;
        OTNode p, n = this;
        do {
            cmp = (p = n).compare(e);
            n = cmp > 0 ? p.right : p.left;
        } while (n != null);
        if (cmp > 0) {
            p.right = new OTNode(e);
        } else {
            p.left = new OTNode(e);
        }
    }

    public int contains(String e) {
        int count = 0;
        OTNode n = this;
        do {
            int cmp = n.compare(e);
            if (cmp > 0) {
                n = n.right;
            } else {
                n = n.left;
                if (cmp == 0) {
                    count++;
                }
            }
        } while (n != null);
        return count;
    }

    public OTNode rmv(String e, int[] cnt) {
        int cmp = compare(e);
        if (cmp > 0) {
            if (right != null) {
                right = right.rmv(e, cnt);
            }
        } else {
            if (left != null) {
                left = left.rmv(e, cnt);
            }
            if (cmp == 0) {
                cnt[0]--;
                if (left == null) {
                    return right;
                }
                OTNode p = left;
                while (p.right != null) {
                    p = p.right;
                }
                p.right = right;
                return left;
            }
        }
        return this;
    }

    public int fill(String[] array, int i) {
        if (left != null) {
            i = left.fill(array, i);
        }
        if (i < array.length) {
            array[i++] = elem;
            if (right != null) {
                i = right.fill(array, i);
            }
        }
        return i;
    }

    public String iter(OTIter iter, boolean next) {
        OTNode n = next ? right : this;
        while (n != null) {
            new OTIter(n, iter);
            n = n.left;
        }
        return elem;
    }
}
