public class ValueSet implements Collection {
    private HashTab tab;

    public ValueSet(HashTab t) {
        tab = t;
    }

    public void add(String element) {
        if (!tab.containsValue(element)) {
            if (!tab.containsKey(element)) {
                tab.put(element, element);
            } else {
                int i = 1;
                while (tab.containsKey(element + "(" + i + ")")) {
                    i++;
                }
                tab.put(element + "(" + i + ")", element);
            }
        }
    }

    public int contains(String e) {
        return tab.countValues(e);
    }

    public int removeAll(String e) {
        return tab.removeValues(e);
    }

    public void clear() {
        tab.clear();
    }

    public int size() {
        return tab.size();
    }

    public String[] toArray() {
        String[] values = new String[size()];
        tab.valueArray(values);
        return values;
    }

    public Iterator iterator() {
        return tab.valueIterator();
    }

    public String toString() {
        String s = "";
        for (String e : this) {
            s += s.equals("") ? e : ", " + e;
        }
        return "{" + s + "}";
    }

    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || o.getClass() != ValueSet.class) {
            return false;
        }
        ValueSet that = (ValueSet) o;
        return this.tab.equals(that.tab);

    }

    public int hashCode() {
        return 12345 * tab.hashCode();
    }
}
