import java.util.HashSet;
import java.util.Set;
import java.util.TreeSet;

public class TestSet {

    public static void main(String[] args) {
        testSet(new HashSet<Integer>());
        testSet(new TreeSet<Integer>());
    }

    private static void testSet(Set<Integer> set) {
        fill(set);
        find(set);
        delete(set);
        System.out.println(set);
    }

    private static void fill(Set<Integer> set) {
        for (char i = 0; i < 60000; i++) {
            set.add((int)(Math.random() * 100000.0));
        }
        System.out.println(set.getClass().getName() + " gefüllt mit " + set.size() + " Einträgen.");
    }

    private static void find(Set<Integer> set) {
        int c = 0;
        for (char i = 0; i < 60000; i++) {
            if (set.contains((int)(Math.random() * 100000.0))) {
                c++;
            }
        }
        System.out.println(c + " Einträge in " + set.getClass().getName() + " gefunden.");
    }

    private static void delete(Set<Integer> set) {
        int c = 0;
        for (char i = 0; i < 60000; i++) {
            if (set.remove((int)(Math.random() * 100000.0))) {
                c++;
            }
        }
        System.out.println(c + " Einträge aus " + set.getClass().getName() + " entfernt.");
        System.out.println(set.size() + " Einträge sind noch übrig.");
    }

}
