import java.io.*;

public class NumberedAuto {
    private static final String errMsg = "Usage: java Numbered <in> <out>";

    public static void main(String[] args) {
        if (args.length != 2) {
            System.err.println(errMsg);
            return;
        }
        try (BufferedReader in = new BufferedReader(new FileReader(args[0]));
             BufferedWriter out = new BufferedWriter(new FileWriter(args[1]))
        ) {
            String line;
            for (int i = 1; (line = in.readLine()) != null; i++) {
                out.write(String.format("%6d: %s\n", i, line));
            }
        } catch (IOException e) {
            System.err.println("I/O Error: " + e.getMessage());
        }
    }
}
